% Autor:
% Datum: 26.06.2018

:- use_module(kellerStorage,[kellerStorage/2]).
:- use_module(foResolution,[rprove/1]).

consistent(Context):-
    readings(Context,Readings),
    check_consistency(Readings,[],ConsReadings),
    print_readings(Readings).

readings([],[]).

readings([S|T],[R|Readings]):-
    kellerStorage(S,R),
    readings(T,Readings).

print_readings([]):-
    print('no more consistent readings').
    
print_readings([R|Readings]):-
    print(R),nl,
    print_readings(Readings).

check_consistency([],Acc,Acc).

check_consistency([R|Readings],Acc,ConReadings):-
    consistent_readings(R,Acc,ConsAcc),
    check_consistency(Readings,ConsAcc,ConsReadings).

consistent_readings([R|T],Acc,[ConsR|ConsAcc]):-
    consistent(R,Acc,ConsR),!,
    consistent_readings(T,Acc,ConsAcc).

consistent_readings([R|T],Acc,ConsAcc):-
    consistent_readings(T,Acc,ConsAcc).

consistent(R,[],R).
consistent(R,[F|Acc],ConsR):-
    rprove(not(and(R,F))),!,
    consistent(and(R,F),Acc,ConsR).